//
// Created by sebastien lato on 2024-03-14.
//

#ifndef SIF1053_TP2_DIVISION_H
#define SIF1053_TP2_DIVISION_H

#include <stdio.h>

// Effectue la division binaire en utilisant la méthode de restauration des restes partiels.
// Retourne le quotient et le reste empaquetés dans un long non signé.
// Le quotient se trouve dans les 16 bits inférieurs, le reste dans les 16 bits supérieurs.
unsigned long division(unsigned short dividende, unsigned short diviseur);

// Écrit le résultat de la division dans un fichier au format spécifié.
void ecrireResultatDansFichier(FILE* fichier, int numeroDivision, unsigned short dividende, unsigned short diviseur, unsigned short quotient, unsigned short reste);



#endif //SIF1053_TP2_DIVISION_H
