/*
 ============================================================================
 TP 2 - SIF1053
Membres de l'equipe  :
Meghalie Welo WELM64510200
Esther Nkwe NKWE68570300
Melqui David Barrero Mejia BARM16039808
 ============================================================================
 */

// Bilbiotheques standard de C
#include <stdio.h> 
#include <stdlib.h>

// Prototype de la fonction division
unsigned int division (unsigned int dvd1, unsigned int dvs1);

//Fonction main
int main()
{
    //Declaration des vairables
    int nbre;
    unsigned int divid;
    unsigned int divis;
    unsigned int quot;
    unsigned int reste;

    //Creation de fichier test
    FILE* Fichier;
    Fichier = fopen("Resultat.txt" , "wb"); // wb Mode d'ouverture des fichiers utilise avec la fonction fopen pour la division binaires

    printf("\n --------------------BIENVENUE--------------------\n");

    do{
        printf("\n Veuillez inscrire le nombre de division a realiser : ");
        fflush(stdout); // represente la sortie standard
        scanf("%d" , &nbre); // Recupere la valeur du nombre de division a realiser
    }
    while (! (nbre >= 0 ));// Repeter tant que le nombre n'est pas superieur ou egale a 0

    for (int i=1; i<=nbre;i++){
        do{
            printf ("\n Veuillez inscrire le dividende de l'operation %d / %d : ", i , nbre);
            fflush(stdout); // represente la sortie standard
            scanf("%u", &divid); // Reprend la valeur du dividende
        }
        //Pour chaque division inscrire la valeur du dividende ( entre 0 et 65535 )
        while (divid < 0 || divid > 65535 ); // Reprend la valeur du dividende
        
        do {
            printf("Veuillez entrer le diviseur de l'operation %d / %d ; ", i , nbre);
            fflush(stdout);// represente la sortie standard
            scanf("%u", &divis); // Reprend la valeur du diviseur
        }
        // Pour chaque division rentrer la valeur du diviseur (entre 1 et 65535)
        while (divis < 1 || divis > 65535);
        quot = division(divid, divis);
        reste = divid % divis;

        //Affichage du resultat dans le fichier test precedemment creer
        fprintf (Fichier, "Division %d : %u / %u = %u reste %u \n", i , divid, divis, quot, reste);

    }
    // Cloture  du fichier 
    fclose(Fichier);
}

/*
Fonction division: 
Effectue la division de nombres entiers positifs de 16 bits
Implementation de la methode de division binaire par restauraration des restes partiels en utilisant
que les operations d'addition, de soustraction et de decalage.

INPUT : VARIABLES DIVIDENDE (dvd1), diviseur (dvs1)
OUTPUT : Reste - Quotient
*/

unsigned int division (unsigned int dvd1, unsigned int dvs1)
{
    dvs1 = dvs1 << 16; // decaler les bits de la valeur contenue dans 'dvs1' de 16 positions vers la gauche

    for (int i=0; i<16; i++) // Pour i allant de 0 a 15
    {
        dvd1 = dvd1 << 1;  // decaler les bits de la valeur contenue dans 'dvd1' de 1 position vers la gauche
       
        if(dvd1 >= dvs1){
            dvd1 = dvd1 - dvs1;
            dvd1 = dvd1 + 1;
        }
    }
    return dvd1; // Returner dvd1
}