#include <stdio.h>
#include <stdlib.h>
/*
KENNE ZOYEM ROSLIN
MBODA RUDY
TCHAMBA MAKAMTE MARC OREL
FOMKOUNG TAGNE MICHAEL CEDRIC

*/

// Dfinition de la fonction de division binaire
unsigned int division(unsigned int dividende, unsigned int diviseur) {
    unsigned int quotient = 0;
    int decalage = 0; // Initialisez le dcalage  zero

    // Tant que le diviseur est inferieur ou gal au dividende
    while (diviseur <= dividende) {
       // Decalage vers la gauche du diviseur
        diviseur = diviseur << 1;
        decalage++;
    }
    decalage--;

    // Effectuez la division binaire
    while (decalage >= 0) {
        if (dividende >= diviseur) {
            dividende -= diviseur;
            quotient |= (1 << decalage); // Mettez  jour le quotient
        }
        diviseur = diviseur >> 1; // Dcalage vers la droite du diviseur
        decalage--;
    }

    // Affichez le reste (facultatif)
    printf("Reste : %u\n", dividende);

    // Retournez le quotient
    return quotient;
}

int main() {
    unsigned int dividende;
    unsigned int diviseur;

    FILE *fichier;
    fichier = fopen("resultats.txt", "w");

    if (fichier == NULL) {
        perror("Erreur lors de l'ouverture du fichier");
        return 1;
    }

    // Demande  l'utilisateur d'entrer le dividende
    printf("Entrez le dividende (entre 0 et 65355) : ");
    scanf("%u", &dividende);
    fprintf(fichier, "Dividende : %u\n", dividende);

    // Demande  l'utilisateur d'entrer le diviseur
    printf("Entrez le diviseur (entre 0 et 65355) : ");
    scanf("%u", &diviseur);
    fprintf(fichier, "Diviseur : %u\n", diviseur);

    // Vrifie si le diviseur est nul
    if (diviseur == 0) {
        fprintf(fichier, "Erreur : La division par zro n'est pas autorise.\n");
        fclose(fichier);
        return 1; // Quitte le programme avec un code d'erreur
    }

    // Appelle la fonction de division binaire et rcupre le quotient
    unsigned int quotient = division(dividende, diviseur);
    fprintf(fichier, "Quotient : %u\n", quotient);

    // Ferme le fichier
    fclose(fichier);
    printf("Les rsultats ont t crits dans le fichier resultats.txt.\n");

    return 0;
}
