#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

/*
* @nom et Prenom : NOUBI NGUIAM ERICA CAREINE           CODE_PERMANANT : NOUE70260200
* @nom et Prenom : LALONG JEAN THIERRY                  CODE_PERMANANT : LALJ01379200
* @nom et Prenom : TENMA YOUANCHI GUILLAUMAR ARTHUS     CODE_PERMANANT : TENG84350100
* @nom et Prenom : MBAH TANTOH DILAN                    CODE_PERMANANT : MBAD92300200
*/

/**
 * Cette fonction effectue une division non signe de deux entiers en utilisant des oprations bit  bit.
 * @param a Dividende, entier non sign  diviser.
 * @param b Diviseur, entier non sign.
 * @return Rsultat de la division de a par b.
 */
unsigned int division(unsigned int a, unsigned int b) {
    // Dcaler le diviseur b de 16 bits vers la gauche pour tre utilis dans la division
    b = b << 16;

    // Boucle pour effectuer la division bit  bit
    for (int i = 0; i < 16; i++) {
        // Dcaler le dividende a de 1 bit vers la gauche pour considrer le prochain bit
        a = a << 1;

        // Vrifier si le dividende est suprieur ou gal au diviseur
        if (a >= b) {
            // Soustraire le diviseur du dividende
            a = a - b;
            // Ajouter 1 au rsultat de la division
            a = a + 1;
        }
    }
    // Retourner le rsultat de la division
    return a;
}



/**
 * Fonction principale du programme qui ralise des divisions non signes en utilisant des oprations bit  bit.
 * Elle demande  l'utilisateur le nombre de divisions  effectuer, puis effectue les divisions demandes.
 */
int main()
{
    unsigned int i,a,b,d,N; // Dclaration des entiers pour les oprations de division
    unsigned short c; // Variable pour stocker les 16 premiers bits du rsultat de la division

    FILE *rep; // Pointeur vers le fichier de rponse
    rep = fopen("reponse.txt","w"); //ouverture du fichier avec w comme regle d'accs en ecriture
    printf("Entrer le nombre de division a effectuer\n");
    scanf("%i",&N); // Demande  l'utilisateur le nombre de divisions  effectuer
    printf("Entrer le ou les divisions a effectuer\n");
    printf("de la facon suivante : a/b exemple : 7/2\n");

    // Boucle pour effectuer les divisions demandes par l'utilisateur
    for(i = 1; i <= N; i++){
        // Demande  l'utilisateur d'entrer les valeurs de a et b pour la division en respectant les plages de valeurs
        do {
            printf("Entrez a (entre 0 et 65535) et b (entre 1 et 65536) pour la division %i: ", i);
        } while (scanf("%i / %i", &a, &b) != 2 || a < 0 || a > 65535 || b < 1 || b > 65536); // Vrification de la saisie et des plages de valeurs pour 16 bits

        d = division(a, b); // Appel de la fonction division pour effectuer la division de a par b
        c = (unsigned short) d; // Recuperation des 16 premiers bits du rsultat de la division
        d = (d >> 16); // Recuperation des 16 derniers bits du rsultat de la division

        // criture de la division et de ses rsultats dans le fichier de rponse
        fprintf(rep, "Division %i: %i/%i = %d reste %i\n", i,a,b,c,d);
    }
    fclose(rep);//fermeture du fichier
    return 0;
}
