/*Auteur: MADIEGA Michel(MADY77340100)
          SAVADOGO Abdoul Azize(SAVA66320300)
		KEYANFE DONGMO ANASTASIE ANGE(KEYA87330300)*/
#include <stdlib.h>

// Fonction pour effectuer la division binaire
unsigned int division(unsigned int dividend, unsigned int divisor) {
    // Décalage du diviseur vers la gauche de 16 positions
    divisor <<= 16;

    for (int j = 0; j <= 15; j++) {
        // Décalage du dividende vers la gauche d'une position à chaque itération
        dividend <<= 1;

        // Vérification du dépassement du diviseur à chaque itération
        if (dividend >= divisor) {
            dividend = dividend - divisor;
            dividend++;
        }
    }

    // La partie haute de la valeur retournée est le quotient,
    // et la partie basse est le reste
    return dividend;
}

// Fonction de vérification des nombres saisis par l'utilisateur
void verification(unsigned int a, unsigned int b) {
    while ((a < 0 || a >= 65535) || (b < 1 || b >= 65535)) {
        printf("Entrez des nombres valides entre 0 et 65535 pour le dividende et 1 et 65535 pour le diviseur : \n");
        scanf("%u / %u", &a, &b);
    }
}

int main() {
    unsigned int num_divisions;
    printf("Entrez le nombre de divisions à effectuer : ");
    scanf("%u", &num_divisions);

    FILE *output_file = fopen("resultats.txt", "w");
    if (output_file == NULL) {
        printf("Erreur lors de l'ouverture du fichier pour l'écriture.\n");
        return 1;
    }

    for (unsigned int i = 0; i < num_divisions; i++) {
        unsigned int dividend, divisor, quotient, remainder;
        printf("Entrez le dividende %u (entre 0 et 65535) : ", i + 1);
        scanf("%u", &dividend);
        printf("Entrez le diviseur %u (entre 1 et 65535) : ", i + 1);
        scanf("%u", &divisor);

        verification(dividend, divisor);

        unsigned int result = division(dividend, divisor);
        quotient = result & 0xFFFF;
        remainder = result >> 16;

        fprintf(output_file, "Division %u : %u / %u = %u reste %u\n", i + 1, dividend, divisor, quotient, remainder);
    }

    fclose(output_file);
    printf("Résultats écrits dans le fichier resultats.txt\n");

    return 0;
}