//KABORE TOUWENDNSIDA JOSIAS KABT68260200
//YENCHI GUIMEYA UDJINE JUNIOR YENU65280200
#include <stdio.h>
#include <stdlib.h>

// Fonction pour effectuer la division
unsigned int division(unsigned int x, unsigned int y);

int main(int argc, char* argv[]) {
    unsigned int i, x, y, z, n;
    unsigned short t;

    FILE *fichier_sortie; // Pointeur vers le fichier de sortie
    fichier_sortie = fopen("resultats.txt", "w"); // Ouverture du fichier en mode criture

    if (fichier_sortie == NULL) {
        printf("Impossible d'ouvrir le fichier de sortie.");
        return 1;
    }

    printf("Saisissez le nombre de divisions a faire : \n");
    scanf("%u", &n);

    // Boucle permettant la validation du nombre de divisions
    for (i = 0; i < n; i++) {
        printf("Entrez les nombres a diviser : ");
        scanf("%u / %u", &x, &y);

        // Vrification que x et y sont dans l'intervalle [0, 65535] et que y n'est pas gal  0
        while ((x < 0 || x > 65535) || (y < 0 || y > 65535) || y == 0) {
            printf("Veuillez saisir des nombres corrects SVP : \n");
            scanf("%u / %u", &x, &y);
        }

        // Appel de la fonction de division
        z = division(x, y);
        t = ((unsigned short)z); // Rsultat de la division (partie entire)
        z = (z >> 16); // Reste de la division

        // Affichage du rsultat dans la console
        printf("Division %u : %u / %u = %u reste %u\n", i + 1, x, y, t, z);

        // criture du rsultat dans le fichier
        fprintf(fichier_sortie, "Division %u : %u / %u = %u reste %u\n", i + 1, x, y, t, z);
    }

    fclose(fichier_sortie); // Fermeture du fichier
    return 0;
}

// Fonction pour effectuer la division de deux nombres entiers positifs de 16 bits
unsigned int division(unsigned int x, unsigned int y) {
    // Dcalage de y sur 16 bits vers la gauche
    y = y << 16;
    int i;
    for (i = 0; i < 16; i++) {
        x = x << 1;
        if (x >= y) {
            x = x - y;
            x = x + 1;
        }
    }
    return x;
}
