/*
************* TP 2 ***************




NOMS ET PRENOMS : DOUNGUE TALLA Blaise Achille
CODE PERMANENT : DOUB04328400



NOMS ET PRENOMS : FANYI YAKAM Divin Sorel Le Roy
CODE PERMANENT : FAND82320401



  
*/
/*
 *******************************************************************************
 la division entière non signée à l’aide de l’algorithme de restauration. 
 L’utilisateur est invité à entrer le nombre de divisions à effectuer, suivi du 
 dividende et du diviseur pour chaque division. 
 Le programme calcule ensuite le quotient et le reste à l’aide de la fonction de 
 division et écrit le résultat dans un fichier nommé « resultats.txt »
 *******************************************************************************
*/
#include <stdio.h>


unsigned int division(unsigned int a, unsigned int b);


int main() {
    unsigned int i, a, b, N;		  /* N est le nombre de division à effectuer */
    FILE *rep; 						  /* Permet de definir qu'on va ouvrir sur disque */
    rep = fopen("resultats.txt", "w");/* resultats.txt est le nom du fichier généré */
    
    // Validation de l'ouverture
    if (rep == NULL) 
		{
			printf("Erreur: impossible d'ouvrir le fichier resultats.txt\n");
			return 1;
		}
	printf("Combien de divisions voulez-vous effectuer ? ");
	scanf("%u", &N);				/*Pointeur sur l'objet en memoire*/
	printf("Entrer la ou les divisions a effectuer\n");
	printf("de la facon suivante : a/b\n");
	for (i = 1; i <= N; i++) 
			{
			scanf("%i / %i",&a,&b);/* Il suffira d'entrer a/b */
			
			// validation du diviseur
			if (b == 0) 
			{
				fprintf(rep,"Division %u : Erreur : division par zéro, le diviseur doit etre different de zero\n", i);
			} 
			else 
				{
					unsigned int res = division(a, b);
					unsigned int q = res >> 16;
					unsigned int r = res & 0xFFFF;
					fprintf(rep, "Division %u : %u / %u = %u reste %u\n", i, a, b, q, r);
				}
			}
    fclose(rep);
    return 0;
}


unsigned int division(unsigned int a, unsigned int b) /* a: DIVIDENDE b: DIVISEUR */
{
    unsigned int q = 0, r = 0;
    int i;
    for (i = 15; i >= 0; i--) {
        r = (r << 1) | ((a >> i) & 1); // Décalage de r vers la gauche et ajout du bit i de a
        if (r >= b) {
            r = r - b;
            q |= (1 << i); // Décalage de q vers la gauche et ajout du bit i à 1
        }
    }
    return (q << 16) | r; // Concaténation de q et r en une seule valeur de 32 bits
}
