//          SIF1053-Tp2
// Created by sebastien lato on 2024-03-14.
//          LATS20057809

#include "menu.h"

/**
 * @brief Point d'entrée principal de l'application.
 *
 * @details Cette fonction est le point d'entrée de l'application. Elle appelle
 *          la fonction menu() pour démarrer le menu interactif de l'application.
 *          La fonction main() reviendra et terminera l'exécution de l'application
 *          une fois que le menu aura été quitté par l'utilisateur.
 *
 * INPUT: aucun (les arguments de la ligne de commande ne sont pas utilisés)
 * OUTPUT: int (code de sortie de l'application, 0 en cas de succès)
 */
int main() {
    menu();
    return 0;
}
