#include <stdio.h>
#include <stdlib.h>


//******************************TP2********************************
//*******************Joseph Dexter JOSD22309100********************
//****************Tieyak Pierre Pradel TIEP84280600****************


// Fonction pour faire une division
// Cette fonction prend en paramtre :
// Dividende : entier non sign reprsentant le dividende de la division
// Diviseur : entier non sign reprsentant le diviseur de la division
// Reste : pointeur vers un entier non sign pour stocker le reste de la division
// Elle retourne le quotient de la division
unsigned int calculDivision(unsigned int dividende, unsigned int diviseur, unsigned int *reste) {
    // Calcul du quotient et du reste de la division
    *reste = dividende % diviseur;
    return dividende / diviseur;
}

// Fonction pour demander le nombre de divisions  effectuer
// Cette fonction prend en paramtre :
// qte_division : pointeur vers un entier pour stocker le nombre de divisions  effectuer
void nombreDeDivision(int *qte_division) {
    printf("Entrez le nombre de divisions que vous voulez effectuer : ");
    scanf("%d", qte_division);
}

// Fonction pour demander le dividende et le diviseur
// Cette fonction prend en paramtre :
// dividende : pointeur vers un entier non sign pour stocker le dividende
// diviseur : pointeur vers un entier non sign pour stocker le diviseur
// numDivision : entier reprsentant le numro de la division
void entrerLesEntiers(unsigned int *dividende, unsigned int *diviseur, int numDivision) {
    printf("Division %d : Entrez le dividende puis espace, aprs entrez le diviseur : ", numDivision + 1);
    scanf("%u %u", dividende, diviseur);
}

// Fonction pour afficher le rsultat dans un fichier texte
// Cette fonction prend en paramtre :
// afficher_Resultat : pointeur vers un fichier o crire le rsultat
// dividende : entier non sign reprsentant le dividende de la division
// diviseur : entier non sign reprsentant le diviseur de la division
// quotient : entier non sign reprsentant le quotient de la division
// reste : entier non sign reprsentant le reste de la division
// num_division : entier reprsentant le numro de la division
void afficherLeResultat(FILE *afficher_Resultat, unsigned int dividende, unsigned int diviseur, unsigned int quotient, unsigned int reste, int num_division) {
    fprintf(afficher_Resultat, "Le resultat de la division %d : %u / %u = %u reste %u\n", num_division + 1, dividende, diviseur, quotient, reste);
}

int main() {
    FILE *afficherResultat;
    // Ouverture du fichier en criture
    afficherResultat = fopen("resultatTexte.txt", "w");

    // Vrifie si le fichier est ouvert avec succs
    if (afficherResultat == NULL) {
        printf("Erreur lors de l'ouverture du fichier resultatTexte.txt.");
        return 1;
    }

    int nombre_divisions;
    nombreDeDivision(&nombre_divisions); // Demande le nombre de divisions  effectuer  l'utilisateur

    // Boucle pour effectuer chaque division
    for (int i = 0; i < nombre_divisions; i++) {
        unsigned int dividende, diviseur, reste;
        entrerLesEntiers(&dividende, &diviseur, i); // Demande les entiers  diviser

        // Vrification du diviseur pour voir s'il est diffrent de zro pour viter la division par zro
        if (diviseur == 0) {
            printf("Erreur : Division par zro.\n");
            continue; // Passe  la prochaine itration de la boucle
        }

        // Effectue la division et rcupre le quotient et le reste
        unsigned int quotient = calculDivision(dividende, diviseur, &reste);
        // crit le rsultat dans le fichier
        afficherLeResultat(afficherResultat, dividende, diviseur, quotient, reste, i);
    }

    // Ferme le fichier
    fclose(afficherResultat);
    printf("Les rsultats sont dans le fichier 'resultatTexte.txt'.\n");

    return 0;
}
