
    //****************************************************************//
   //                                                                //
  // Nom et prenom : Hader Hassan  || Code permanent : HADH09289500 //
 //                                                                //
//****************************************************************//


#include <stdio.h>
#include <stdlib.h>
#include <conio.h>


unsigned int division(unsigned int dividende, unsigned int diviseur) // La fonction le resultat de la division
{
    diviseur = diviseur << 16; // Dcaler le diviseur pour le mettre sur 16 bits
    for (unsigned int i = 0; i < 16; i++)
    {
        dividende = dividende << 1; // Dcaler du dividende vers la gauche
        if (dividende >= diviseur)
        {
            dividende -= diviseur;
            dividende += 1;
        }
    }
    return dividende; // Retourne le rsultat de la division (le reste et le quotient combins)
}

void main()
{
    unsigned int dividende, diviseur,resultat, reste;
    int i, n;
    unsigned short quotient;
    printf("Entrez le nombre de divisions a effectuer : ");
    scanf("%d", &n);

    FILE *rep;
    rep = fopen("reponse.txt", "w");
    for (i = 1; i <= n; i++)
    {
        do
        {
            printf("Entrez le dividende (entre 0 et 65535) : de la division %d : ", i );
            scanf("%u", &dividende);
        } while (dividende < 0 || dividende > 65535); // Vrification de dividende (la plage 0 et 65535)

        do
        {
            printf("Entrez le diviseur (entre 1 et 65535) de la division %d : ", i );
            scanf("%u", &diviseur);
        } while (diviseur <=0  || diviseur > 65535); // Vrification de diviseur (la plage 1 et 65535)

        resultat = division(dividende, diviseur);      // Appel de la fonction "division"
        quotient = resultat & 0xFFFF;  // Extraction du quotient  partir du rsultat (les 16 premiers bits)
        reste = resultat >> 16;                         // Extraction du reste  partir du rsultat (les 16 derniers bits)


        fprintf(rep, "Division %d: %u / %u = %u reste %u\n", i + 1, dividende, diviseur, quotient, reste); // criture des rsultats dans le fichier
    }
    fclose(rep);
    printf("Les resultats sont ecrits dans le fichier reponse.txt\n");
}
