

                                         /*  Travail_Pratique_2 SIF_1053

                                             NGUIMDO NGAFFO Livia Joyce  */



/*DESCRIPTION :
NOM DE LA FONCTION :division

DESCRIPTION:
Cette fonction ralise la division binaire par restauration des restes partiel en utilisant une fonction combinant l'addition, la soustraction et le dcalage de bits.
Elle prend en entre le dividende (dividend), le diviseur (divisor) et un pointeur vers le reste (remainder).

LES PARAMETRES:

INPUT:
unsigned int a: (dividende, nombre de 16 bits).
unsigned int b: (diviseur, nombre de 16 bits).
Le paramtre remainder est un pointeur vers unsigned int et contiendra le reste de la division aprs l'appel de la fonction.

OUTPUT:
unsigned int : Le rsultat de la division.
La fonction retourne le quotient de la division.
*/

#include <stdio.h>
#include <stdlib.h>

unsigned int division(unsigned int a, unsigned int b);

/*

Fonction principale (main) qui gre la boucle de division en sollicitant l'entre de l'utilisateur pour les calculs, puis les enregistre dans le fichier "Reponse.txt".

INPUT:
Aucun .

OUTPUT:
Retourne 0 si tout s'est bien droul

*/
// fonction principale
int main() {

    /*Dclaration des variables*/

    unsigned int i, dividende, diviseur, reste, nbDivisions;

    long validationDividende, validationDiviseur;

    unsigned short resultat;


    // Ouverture du fichier "Reponse.txt"

    FILE* Reponse;
    Reponse = fopen("Reponse.txt", "w");


    /* Demande de nombre de division  effectuer */

    printf("Entrez le nombre de divisions a effectuer : ");
    scanf("%i", &nbDivisions);


    /* Afficher les instructions */

    printf("Entrez la ou les divisions a effectuer de la facon suivante : a/b\n");

    for (i = 1; i <= nbDivisions; i++) {
        scanf("%li/%li", &validationDividende, &validationDiviseur);


    /* Validation des entres de l'utilisateur afin de s'assurer qu'elles correspondent bien  des valeurs de 16 bits*/

        if (validationDividende >= 0 && validationDividende <= 65535 && validationDiviseur > 0 && validationDiviseur <= 65535) {
            dividende = validationDividende;
            diviseur = validationDiviseur;
            reste = division(dividende, diviseur);
            resultat = (unsigned short)reste;
            reste = (reste >> 16);
            fprintf(Reponse, "Division %i : %i/%i = %d reste %i\n", i, dividende, diviseur, resultat, reste);
        }
        else
            fprintf(Reponse, "Division %i : Invalide\n", i, dividende, diviseur, resultat, reste);
    }
    // fermeture du fichier texte (Reponse)

    fclose(Reponse);

    return 0;
}


unsigned int division(unsigned int a, unsigned int b) {

    int i;

     /*Dcalage de b de 16 bits  gauche*/

    b = b << 16;
    for (i = 0; i <= 15; i++) {
        a = a << 1;

        if (a >= b) {
            a = a - b;
            a = a + 1;
        }
    }
    return a;
}


