/*
les participants:
GADS06279400: SERIGNE FALLOU GADIAGA
DANM15379700: MOUHAMADOU SOUNKOUNG DANFAKHA
FAYB23319800: BABACAR FAYE
MBEM77280000: MARIANE MBENGUE
*/
#include <stdio.h>
//fonction valeur_absolue qui retourne la valeur absolu dun nombre passe en parametre
int valeur_absolue(int nombre)
{
    if(nombre>=0)
        return nombre;
    return -1*nombre;
}

/*Fonction de division qui prend en argument :
-le dividende et le diviseur (passage par valeur)
-le quotient et le reste (passage par adress)
puis fait la division sur 16bits du dividende par le diviseur 
et mets a jour les valeurs du quotient et du reste
*/
void division(int dividende, int diviseur,int *quotient,int *reste) {
    *quotient = 0;
    *reste = 0;
    int sign = 1;

    if ((dividende < 0) ^ (diviseur < 0)) {
        sign = -1;
    }

    //calculer les valeurs absolues du dividende et du diviseur
    dividende=valeur_absolue(dividende);
    diviseur=valeur_absolue(diviseur);

    //boucle for pour faire la division sur !6bits
    for (int i = 15; i >= 0; i--) {
        *reste <<= 1;
        *reste  |= (dividende >> i) & 1;
        if (*reste  >= diviseur) {
            *reste  -= diviseur;
            *quotient |= 1 << i;
            
        }
    }
    *quotient *= sign;
}

int main() {

    //Ouverture du fichier ou on veut ecrire les resultats de notre division 
    //si le fichier n'existe pas il est creer dynamiquement
    //et s'il existe son contenu sera ecrasé
    FILE *fichier_divisions;
    fichier_divisions = fopen("resultats.txt", "w");

    //test si le fichier est correctement ouvert sinon on quitte le programme
    if (fichier_divisions == NULL) { 
        printf("Erreur lors de l'ouverture du fichier.\n");
        return 1;
    }

    int dividende;
    int diviseur;
    int quotient,reste;
    
    int i=0;

    //saisi du nombre de diision que l'on souhaite effectuer
    int nbr_division;
    printf("Veillez saisir le nombre de division que tu veux effectuer : ");
    scanf("%d",&nbr_division);

    //boucle while nous permettant de faire autant de divisions que le nombre saisi
    while(i<nbr_division)
    {
        //boucle do-while pour controler la saisi de l'utilisateur
        //il doit saisir un dividende entre 0 et 65535
        do
        {
            printf("Veillez saisir le dividende de la division %d (entre 0 et 65535): ",i+1);
            scanf("%d",&dividende);
        }while(dividende < 0 || dividende > 65535);

        //boucle do-while pour controler la saisi de l'utilisateur
        //il doit saisir un diviseur entre 0 et 65535
        do
        {
            printf("Veillez saisir le diviseur de la division %d (entre 0 et 65535): ",i+1);
            scanf("%d",&diviseur);
        }while(diviseur < 0 || diviseur > 65535);

        quotient=0,reste=0;

        //Apel de la fonction division 
        division(dividende, diviseur,&quotient,&reste);

        //ecriture du resulat dans notre fichier sous la forme demandee
        fprintf(fichier_divisions,"Division %d: %d/%d=%d resste %d\n",i+1,dividende,diviseur,quotient,reste );
        i++;
     }

    //fermeture du fichier apres avoir effectuer toutes les divisions
    fclose(fichier_divisions);
    return 0;
}


